package alma.tmcdb.cloning;

import alma.acs.tmcdb.BaseElement;
import net.sf.beanlib.spi.BeanTransformerSpi;
import net.sf.beanlib.spi.CustomBeanTransformerSpi;

import alma.acs.tmcdb.HWConfiguration;

/**
 * Factory to return a transformer which will 'pass through' (i.e. return the identical object reference)
 * any 'global' domain classes.
 * 
 * @author sharrington
 */
public class BaseElementTransformerFactory implements CustomBeanTransformerSpi.Factory 
{
	private HWConfiguration configBeingCloned;

	public BaseElementTransformerFactory(HWConfiguration configBeingCloned)
	{
		this.configBeingCloned = configBeingCloned;
	}

	public CustomBeanTransformerSpi newCustomBeanTransformer(BeanTransformerSpi beanTransformer) {
		return new BaseElementTransformer(beanTransformer, configBeingCloned);
	}
}
