/*
 * ALMA - Atacama Large Millimeter Array
 * (c) European Southern Observatory, 2002
 * (c) Associated Universities Inc., 2002
 * Copyright by ESO (in the framework of the ALMA collaboration),
 * Copyright by AUI (in the framework of the ALMA collaboration),
 * All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307  USA
 *
 * "@(#) $Id: FrontEnd.java,v 1.8 2011/05/02 08:47:46 rtobar Exp $"
 */
package alma.tmcdb.domain;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import alma.acs.util.UTCUtility;

public class FrontEnd extends BaseElement {
    
    private Long commissionDate;
    private Set<AntennaToFrontEnd> scheduledAntennaInstallations =
        new HashSet<AntennaToFrontEnd>();

    public FrontEnd() {}

    public FrontEnd(String name, Date commissionDate) {
        this(name, UTCUtility.utcJavaToOmg(commissionDate.getTime()));
    }
    
    public FrontEnd(String name, Long commissionDate) {
        super(null, name, BaseElementType.FrontEnd);
        this.commissionDate = commissionDate;
    }
    
    public Long getCommissionDate() {
        return commissionDate;
    }

    public void setCommissionDate(Long commissionDate) {
        this.commissionDate = commissionDate;
    }

    public Set<AntennaToFrontEnd> getScheduledAntennaInstallations() {
        return scheduledAntennaInstallations;
    }

    public void setScheduledAntennaInstallations(Set<AntennaToFrontEnd> scheduledAntennaInstallations) {
        this.scheduledAntennaInstallations = scheduledAntennaInstallations;
    }
}
