/*******************************************************************************
 * ALMA - Atacama Large Millimeter Array
 * Copyright (c) ESO - European Southern Observatory, 2011
 * (in the framework of the ALMA collaboration).
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *******************************************************************************/
package alma.obops.tmcdb.alarms.ui.tree.helpers.lists;

import java.util.List;

import org.eclipse.swt.graphics.Image;

import alma.acs.tmcdb.Configuration;
import alma.acs.tmcdb.FaultCode;
import alma.obops.tmcdb.alarms.ui.tree.helpers.FaultCodeHelper;
import alma.obops.tmcdb.alarms.ui.tree.helpers.ListHelper;
import alma.obops.tmcdb.alarms.ui.utils.RcpUtils;

public class FaultCodeListHelper extends ListHelper 
{
	@SuppressWarnings("unused")
	private Configuration configuration;
	
	public FaultCodeListHelper(List<?> list, Configuration configuration) 
	{
		super(list);
		this.configuration = configuration;
	}
	
	@Override
	public Image getFirstColumnImage() {
		return RcpUtils.getImage("icons/faultcode.png");
	}
	
	@Override 
	public String getFirstColumnText()
	{
		return "Fault Codes";
	}
	
	@Override 
	public Object[] getChildren()
	{
		Object[] children = super.getChildren();
		FaultCode[] retVal = new FaultCode[children.length];
		int count = 0;
		for(Object codeObj : children)
		{
			FaultCode code = (FaultCode) codeObj;
			code = FaultCodeHelper.findFaultCode(code);
			retVal[count++] = code;
		}
		
		return retVal;
	}
}
