/*******************************************************************************
 * ALMA - Atacama Large Millimeter Array
 * Copyright (c) ESO - European Southern Observatory, 2011
 * (in the framework of the ALMA collaboration).
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *******************************************************************************/
/**
 * TmcdbGui.java
 *
 * Copyright European Southern Observatory 2008
 */

package alma.obops.tmcdbgui;

import java.util.logging.Logger;

import alma.obops.tmcdbgui.rsviewer.ResultSetUpdater;
import alma.obops.utils.GeneralUtils;

/**
 * A central repository of common stuff.
 *
 * @author amchavan, Sep 12, 2008
 * 
 */



public class TmcdbGui {

    /** Used to updated SQL result sets in the "raw data" view */
    protected static ResultSetUpdater resultSetUpdater;
    
    /** Where we log our messages */
    protected static Logger logger;

    /** Accessor for {@link #resultSetUpdater} */
    public static ResultSetUpdater getResultSetUpdater() {
        return resultSetUpdater;
    }

    /** Accessor for {@link #resultSetUpdater} */
    public static void setResultSetUpdater( ResultSetUpdater resultSetUpdater) {
        TmcdbGui.resultSetUpdater = resultSetUpdater;
    }

    /** Accessor for {@link #logger} */
    public static Logger getLogger() {
        if( logger == null ) {
            logger = GeneralUtils.getAcsLogger("TmcdbExplorer");
        }
        return TmcdbGui.logger;
    }
}
