/*******************************************************************************
 * ALMA - Atacama Large Millimeter Array
 * Copyright (c) ESO - European Southern Observatory, 2011
 * (in the framework of the ALMA collaboration).
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *******************************************************************************/
package alma.obops.tmcdbgui.editors.sorters;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;

import alma.obops.tmcdbgui.utils.DelayEditingUtils;
import alma.obops.tmcdbgui.views.providers.XpDelayModelRow;

public class XpDelaysViewerSorter extends ViewerSorter
{
	@Override
	public int compare(Viewer viewer, Object e1, Object e2) {
		XpDelayModelRow delay1 = (XpDelayModelRow) e1;
		XpDelayModelRow delay2 = (XpDelayModelRow) e2;
		Integer delay1Val = DelayEditingUtils.getIntFromReceiverBandEnum(delay1.getBand());
		Integer delay2Val = DelayEditingUtils.getIntFromReceiverBandEnum(delay2.getBand());
		int rc = delay1Val.compareTo(delay2Val);
		return rc;
	}
}