/*******************************************************************************
 * ALMA - Atacama Large Millimeter Array
 * Copyright (c) ESO - European Southern Observatory, 2011
 * (in the framework of the ALMA collaboration).
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *******************************************************************************/
package alma.obops.tmcdbgui.handlers;

import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.WorkbenchException;

import alma.acs.tmcdb.BACIProperty;
import alma.obops.tmcdbgui.editors.BACIPropertyEditor;
import alma.obops.tmcdbgui.editors.inputs.BACIPropertyEditorInput;
import alma.obops.tmcdbgui.perspectives.SwConfigurationPerspective;

/**
 * Action for editing baci properties.
 * @author sharring
 */
public class EditBACIPropertyAction extends AbstractEditObjectAction 
{
	private String ID = "alma.obops.tmcdbgui.handlers.EditBACIPropertyAction";
	
	 public EditBACIPropertyAction(IWorkbenchWindow window) {
		 super(BACIProperty.class, true, window);
		 setId(ID);
		 setText("Edit BACIProperty");
		 setToolTipText("Opens the BACIProperty in an editor");
	 }

	 public void run() {
		 try {
			 BACIProperty bprop = (BACIProperty)_selection.getFirstElement();
			 BACIPropertyEditorInput bpei = new BACIPropertyEditorInput(bprop);
			 _window.getWorkbench().showPerspective(SwConfigurationPerspective.ID, _window);
			 _window.getActivePage().openEditor(bpei, BACIPropertyEditor.ID);
		 } catch (WorkbenchException e) {
			 e.printStackTrace();
			 // TODO Proper exception handling?
		 }
	 }

}
