/*******************************************************************************
 * ALMA - Atacama Large Millimeter Array
 * Copyright (c) ESO - European Southern Observatory, 2011
 * (in the framework of the ALMA collaboration).
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *******************************************************************************/
/**
 * ResultSetCallback.java
 * 
 * Copyright European Southern Observatory 2008
 */

package alma.obops.tmcdbgui.rsviewer;


/**
 * Classes implementing this interface are capable of updating a result set.
 * 
 * @author amchavan, Sep 1, 2008
 * 
 */


public interface ResultSetCallback {
    
    /**
     * Update an element of the result set.
     * 
     * @param row       The result set row to update
     * @param column    The result set column to update
     * @param newvalue  The new value for the element
     */
    public void updateResultSet( int row, int column, String newvalue );
}
