/*******************************************************************************
 * ALMA - Atacama Large Millimeter Array
 * Copyright (c) ESO - European Southern Observatory, 2011
 * (in the framework of the ALMA collaboration).
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *******************************************************************************/
package alma.obops.tmcdbgui.search;


public enum TmcdbQueryTables {

	COMPONENT("Component", "icons/component.png"),
	CONTAINER("Container", "icons/container.gif"),
	CONFIGURATION("Configuration", "icons/configuration.png"),
	COMPONENT_TYPE("Component Type", "icons/component-type.png"),
	ASSEMBLY_TYPE("AssemblyType", "icons/type.png"),
	COMPUTER("Computer", "icons/computer.gif"),
	ASSEMBLY("Assembly", "icons/assembly.png"),
	BACI_PROPERTY("BACI Property", "icons/baci-property.gif");

	private String niceName;
	private String iconName;

	private TmcdbQueryTables(String name, String icon) {
		niceName = name;
		iconName = icon;
	}

	public String getNiceName() {
		return niceName;
	}

	public String getIconName() {
		return iconName;
	}
}