/*******************************************************************************
 * ALMA - Atacama Large Millimeter Array
 * Copyright (c) ESO - European Southern Observatory, 2011
 * (in the framework of the ALMA collaboration).
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *******************************************************************************/
package alma.obops.tmcdbgui.views.providers;

import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;

import alma.obops.tmcdb.alarms.ui.utils.RcpUtils;
import alma.tmcdb.domain.AssemblyType;

public class DeviceLibrariesTableLabelProvider extends LabelProvider implements ITableLabelProvider {

	@Override
	public Image getColumnImage(Object element, int columnIndex) {
		if( columnIndex == 0 && element instanceof AssemblyType )
			return RcpUtils.getImage("icons/type.png");
		return null;
	}

	@Override
	public String getColumnText(Object element, int columnIndex) {

		if( !(element instanceof AssemblyType) )
			return null;

		AssemblyType at = (AssemblyType)element;
		switch(columnIndex) {
			case 0:
				return at.getName();
			case 1:
				return at.getProductionCode();
			case 2:
				return at.getSimulatedCode();
			default:
				return null;
		}
	}

	public String getText(Object element) {
		return getColumnText(element, 0);
	}

}