/*******************************************************************************
 * ALMA - Atacama Large Millimeter Array
 * Copyright (c) ESO - European Southern Observatory, 2011
 * (in the framework of the ALMA collaboration).
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *******************************************************************************/
/**
 * ComponentComparator.java
 */
package alma.obops.tmcdbgui.views.providers.helpers.software;

import java.util.Comparator;

import alma.acs.tmcdb.Component;
import alma.obops.tmcdbgui.utils.LabelHelper;

/**
 * A comparator for <code>Component</code> objects, useful to show sorted elements in a widget
 * @author rtobar, Feb 22, 2010
 *
 */
public class ComponentComparator implements Comparator<Component> {

	@Override
	public int compare(Component c1, Component c2) {
		String n1 = LabelHelper.getFullPath(c1, false);
		String n2 = LabelHelper.getFullPath(c2, false);
		return n1.compareTo(n2);
	}

}
