package alma.acs.tmcdb;
// Generated Apr 24, 2021, 3:15:50 AM by Hibernate Tools 5.3.7.Final


import alma.hibernate.util.StringEnumUserType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;
import org.hibernate.annotations.Type;
import org.hibernate.annotations.TypeDef;
import org.hibernate.annotations.TypeDefs;

/**
 * FEDelay generated by hbm2java
 */
@SuppressWarnings("serial")
@Entity
@Table(name="`FEDELAY`"
    , uniqueConstraints =  @UniqueConstraint(columnNames={"`ANTENNAID`", "`RECEIVERBAND`", "`POLARIZATION`", "`SIDEBAND`"})
)
@TypeDefs({
@TypeDef(name="ReceiverBandEnum", typeClass=StringEnumUserType.class,
   parameters={ @Parameter(name="enumClassName", value="alma.acs.tmcdb.ReceiverBandEnum") }),
@TypeDef(name="PolarizationEnum", typeClass=StringEnumUserType.class,
   parameters={ @Parameter(name="enumClassName", value="alma.acs.tmcdb.PolarizationEnum") }),
@TypeDef(name="SideBandEnum", typeClass=StringEnumUserType.class,
   parameters={ @Parameter(name="enumClassName", value="alma.acs.tmcdb.SideBandEnum") })
})
public class FEDelay extends alma.acs.tmcdb.translator.TmcdbObject implements java.io.Serializable {


     protected Integer FEDelayId;
     protected Antenna antenna;
     protected ReceiverBandEnum receiverBand;
     protected PolarizationEnum polarization;
     protected SideBandEnum sideBand;
     protected Double delay;
     protected Double delayError;
     protected Long observationTime;
     protected String execBlockUID;
     protected Integer scanNumber;

    public FEDelay() {
    }
   
    @Id @GeneratedValue(generator="alma_acs_tmcdb_FEDelay_FEDelayIdGenerator")
    @GenericGenerator(name="alma_acs_tmcdb_FEDelay_FEDelayIdGenerator", strategy="native",
       parameters = {@Parameter(name="sequence", value="FEDelay_seq")}
	)

    
    @Column(name="`FEDELAYID`", unique=true, nullable=false)
    public Integer getFEDelayId() {
        return this.FEDelayId;
    }

    
    public void setFEDelayId(Integer FEDelayId) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("FEDelayId", this.FEDelayId, this.FEDelayId = FEDelayId);
        else
            this.FEDelayId = FEDelayId;
    }


@ManyToOne(fetch=FetchType.LAZY)
    @JoinColumn(name="`ANTENNAID`", nullable=false)
    public Antenna getAntenna() {
        return this.antenna;
    }

    
    public void setAntenna(Antenna antenna) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("antenna", this.antenna, this.antenna = antenna);
        else
            this.antenna = antenna;
    }


    
    @Column(name="`RECEIVERBAND`", nullable=false, length=128)
	@Type(type="ReceiverBandEnum")
    public ReceiverBandEnum getReceiverBand() {
        return this.receiverBand;
    }

    
    public void setReceiverBand(ReceiverBandEnum receiverBand) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("receiverBand", this.receiverBand, this.receiverBand = receiverBand);
        else
            this.receiverBand = receiverBand;
    }


    
    @Column(name="`POLARIZATION`", nullable=false, length=128)
	@Type(type="PolarizationEnum")
    public PolarizationEnum getPolarization() {
        return this.polarization;
    }

    
    public void setPolarization(PolarizationEnum polarization) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("polarization", this.polarization, this.polarization = polarization);
        else
            this.polarization = polarization;
    }


    
    @Column(name="`SIDEBAND`", nullable=false, length=128)
	@Type(type="SideBandEnum")
    public SideBandEnum getSideBand() {
        return this.sideBand;
    }

    
    public void setSideBand(SideBandEnum sideBand) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("sideBand", this.sideBand, this.sideBand = sideBand);
        else
            this.sideBand = sideBand;
    }


    
    @Column(name="`DELAY`", nullable=false, precision=64, scale=0)
    public Double getDelay() {
        return this.delay;
    }

    
    public void setDelay(Double delay) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("delay", this.delay, this.delay = delay);
        else
            this.delay = delay;
    }


    
    @Column(name="`DELAYERROR`", precision=64, scale=0)
    public Double getDelayError() {
        return this.delayError;
    }

    
    public void setDelayError(Double delayError) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("delayError", this.delayError, this.delayError = delayError);
        else
            this.delayError = delayError;
    }


    
    @Column(name="`OBSERVATIONTIME`")
    public Long getObservationTime() {
        return this.observationTime;
    }

    
    public void setObservationTime(Long observationTime) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("observationTime", this.observationTime, this.observationTime = observationTime);
        else
            this.observationTime = observationTime;
    }


    
    @Column(name="`EXECBLOCKUID`", length=100)
    public String getExecBlockUID() {
        return this.execBlockUID;
    }

    
    public void setExecBlockUID(String execBlockUID) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("execBlockUID", this.execBlockUID, this.execBlockUID = execBlockUID);
        else
            this.execBlockUID = execBlockUID;
    }


    
    @Column(name="`SCANNUMBER`")
    public Integer getScanNumber() {
        return this.scanNumber;
    }

    
    public void setScanNumber(Integer scanNumber) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("scanNumber", this.scanNumber, this.scanNumber = scanNumber);
        else
            this.scanNumber = scanNumber;
    }



   public boolean equalsContent(Object other) {
         if ( (this == other ) ) return true;
		 if ( (other == null ) ) return false;
		 if ( !(other instanceof FEDelay) ) return false;
		 FEDelay castOther = ( FEDelay ) other;

		 return ( (this.getAntenna()==castOther.getAntenna()) || ( this.getAntenna()!=null && castOther.getAntenna()!=null && this.getAntenna().equals(castOther.getAntenna()) ) )
 && ( (this.getReceiverBand()==castOther.getReceiverBand()) || ( this.getReceiverBand()!=null && castOther.getReceiverBand()!=null && this.getReceiverBand().equals(castOther.getReceiverBand()) ) )
 && ( (this.getPolarization()==castOther.getPolarization()) || ( this.getPolarization()!=null && castOther.getPolarization()!=null && this.getPolarization().equals(castOther.getPolarization()) ) )
 && ( (this.getSideBand()==castOther.getSideBand()) || ( this.getSideBand()!=null && castOther.getSideBand()!=null && this.getSideBand().equals(castOther.getSideBand()) ) );
   }

   public int hashCodeContent() {
         int result = 17;

         
         result = 37 * result + ( getAntenna() == null ? 0 : this.getAntenna().hashCode() );
         result = 37 * result + ( getReceiverBand() == null ? 0 : this.getReceiverBand().hashCode() );
         result = 37 * result + ( getPolarization() == null ? 0 : this.getPolarization().hashCode() );
         result = 37 * result + ( getSideBand() == null ? 0 : this.getSideBand().hashCode() );
         
         
         
         
         
         return result;
   }


}


