package alma.acs.tmcdb;
// Generated Apr 24, 2021, 3:15:50 AM by Hibernate Tools 5.3.7.Final


import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;
import org.hibernate.annotations.Cascade;
import org.hibernate.annotations.CascadeType;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

/**
 * FocusModel generated by hbm2java
 */
@SuppressWarnings("serial")
@Entity
@Table(name="`FOCUSMODEL`"
    , uniqueConstraints =  @UniqueConstraint(columnNames="`ANTENNAID`")
)
public class FocusModel extends alma.acs.tmcdb.translator.TmcdbObject implements alma.tmcdb.history.Identifiable,java.io.Serializable {


     protected Integer focusModelId;
     protected Antenna antenna;
     protected Long observationTime;
     protected String execBlockUID;
     protected Integer scanNumber;
     protected String softwareVersion;
     protected String comments;
     protected Double sourceDensity;
     protected Boolean locked;
     protected Boolean increaseVersion;
     protected Integer currentVersion;
     protected String who;
     protected String changeDesc;
     private Set<FocusModelCoeff> focusModelCoeffs = new HashSet<FocusModelCoeff>(0);

    public FocusModel() {
    }
   
    @javax.persistence.Transient
    public Long getId() {
    	return new Long(focusModelId);
    }
    @Id @GeneratedValue(generator="alma_acs_tmcdb_FocusModel_FocusModelIdGenerator")
    @GenericGenerator(name="alma_acs_tmcdb_FocusModel_FocusModelIdGenerator", strategy="native",
       parameters = {@Parameter(name="sequence", value="FocusModel_seq")}
	)

    
    @Column(name="`FOCUSMODELID`", unique=true, nullable=false)
    public Integer getFocusModelId() {
        return this.focusModelId;
    }

    
    public void setFocusModelId(Integer focusModelId) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("focusModelId", this.focusModelId, this.focusModelId = focusModelId);
        else
            this.focusModelId = focusModelId;
    }


@ManyToOne(fetch=FetchType.LAZY)
    @JoinColumn(name="`ANTENNAID`", unique=true, nullable=false)
    public Antenna getAntenna() {
        return this.antenna;
    }

    
    public void setAntenna(Antenna antenna) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("antenna", this.antenna, this.antenna = antenna);
        else
            this.antenna = antenna;
    }


    
    @Column(name="`OBSERVATIONTIME`")
    public Long getObservationTime() {
        return this.observationTime;
    }

    
    public void setObservationTime(Long observationTime) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("observationTime", this.observationTime, this.observationTime = observationTime);
        else
            this.observationTime = observationTime;
    }


    
    @Column(name="`EXECBLOCKUID`", length=100)
    public String getExecBlockUID() {
        return this.execBlockUID;
    }

    
    public void setExecBlockUID(String execBlockUID) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("execBlockUID", this.execBlockUID, this.execBlockUID = execBlockUID);
        else
            this.execBlockUID = execBlockUID;
    }


    
    @Column(name="`SCANNUMBER`")
    public Integer getScanNumber() {
        return this.scanNumber;
    }

    
    public void setScanNumber(Integer scanNumber) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("scanNumber", this.scanNumber, this.scanNumber = scanNumber);
        else
            this.scanNumber = scanNumber;
    }


    
    @Column(name="`SOFTWAREVERSION`", length=100)
    public String getSoftwareVersion() {
        return this.softwareVersion;
    }

    
    public void setSoftwareVersion(String softwareVersion) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("softwareVersion", this.softwareVersion, this.softwareVersion = softwareVersion);
        else
            this.softwareVersion = softwareVersion;
    }


    
    @Column(name="`COMMENTS`", length=16777216)
    public String getComments() {
        return this.comments;
    }

    
    public void setComments(String comments) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("comments", this.comments, this.comments = comments);
        else
            this.comments = comments;
    }


    
    @Column(name="`SOURCEDENSITY`", precision=64, scale=0)
    public Double getSourceDensity() {
        return this.sourceDensity;
    }

    
    public void setSourceDensity(Double sourceDensity) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("sourceDensity", this.sourceDensity, this.sourceDensity = sourceDensity);
        else
            this.sourceDensity = sourceDensity;
    }


    
    @Column(name="`LOCKED`")
    public Boolean getLocked() {
        return this.locked;
    }

    
    public void setLocked(Boolean locked) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("locked", this.locked, this.locked = locked);
        else
            this.locked = locked;
    }


    
    @Column(name="`INCREASEVERSION`")
    public Boolean getIncreaseVersion() {
        return this.increaseVersion;
    }

    
    public void setIncreaseVersion(Boolean increaseVersion) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("increaseVersion", this.increaseVersion, this.increaseVersion = increaseVersion);
        else
            this.increaseVersion = increaseVersion;
    }


    
    @Column(name="`CURRENTVERSION`")
    public Integer getCurrentVersion() {
        return this.currentVersion;
    }

    
    public void setCurrentVersion(Integer currentVersion) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("currentVersion", this.currentVersion, this.currentVersion = currentVersion);
        else
            this.currentVersion = currentVersion;
    }


    
    @Column(name="`WHO`", length=128)
    public String getWho() {
        return this.who;
    }

    
    public void setWho(String who) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("who", this.who, this.who = who);
        else
            this.who = who;
    }


    
    @Column(name="`CHANGEDESC`", length=16777216)
    public String getChangeDesc() {
        return this.changeDesc;
    }

    
    public void setChangeDesc(String changeDesc) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("changeDesc", this.changeDesc, this.changeDesc = changeDesc);
        else
            this.changeDesc = changeDesc;
    }


@OneToMany(fetch=FetchType.LAZY, mappedBy="focusModel")
    @Cascade( {CascadeType.ALL, CascadeType.DELETE_ORPHAN} )
    public Set<FocusModelCoeff> getFocusModelCoeffs() {
        return this.focusModelCoeffs;
    }

    
    public void setFocusModelCoeffs(Set<FocusModelCoeff> focusModelCoeffs) {    
    	this.focusModelCoeffs = focusModelCoeffs;
    }

	public void addFocusModelCoeffs(Set<FocusModelCoeff> elements) {
		if( this.focusModelCoeffs != null )
			for(Iterator<FocusModelCoeff> it = elements.iterator(); it.hasNext(); )
				addFocusModelCoeffToFocusModelCoeffs((FocusModelCoeff)it.next());
	}

	public void addFocusModelCoeffToFocusModelCoeffs(FocusModelCoeff element) {
		if( !this.focusModelCoeffs.contains(element) ) {
			this.focusModelCoeffs.add(element);
		}
	}



   public boolean equalsContent(Object other) {
         if ( (this == other ) ) return true;
		 if ( (other == null ) ) return false;
		 if ( !(other instanceof FocusModel) ) return false;
		 FocusModel castOther = ( FocusModel ) other;

		 return ( (this.getAntenna()==castOther.getAntenna()) || ( this.getAntenna()!=null && castOther.getAntenna()!=null && this.getAntenna().equals(castOther.getAntenna()) ) );
   }

   public int hashCodeContent() {
         int result = 17;

         
         result = 37 * result + ( getAntenna() == null ? 0 : this.getAntenna().hashCode() );
         
         
         
         
         
         
         
         
         
         
         
         
         return result;
   }


}


