package alma.acs.tmcdb;
// Generated Apr 24, 2021, 3:15:50 AM by Hibernate Tools 5.3.7.Final


import alma.hibernate.util.StringEnumUserType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;
import org.hibernate.annotations.Type;
import org.hibernate.annotations.TypeDef;

/**
 * Holography generated by hbm2java
 */
@SuppressWarnings("serial")
@Entity
@Table(name="`HOLOGRAPHY`"
)
@TypeDef(name="ObsModeEnum", typeClass=StringEnumUserType.class,
   parameters={ @Parameter(name="enumClassName", value="alma.acs.tmcdb.ObsModeEnum") })
public class Holography extends alma.acs.tmcdb.translator.TmcdbObject implements java.io.Serializable {


     protected Integer holographyId;
     protected Antenna antennaByReferenceantenna;
     protected Antenna antennaByAntennaid;
     protected Long observationTime;
     protected String execBlockUID;
     protected Integer scanNumber;
     protected Double observationDuration;
     protected Double lowElevation;
     protected Double highElevation;
     protected Double mapSize;
     protected String softwareVersion;
     protected ObsModeEnum obsMode;
     protected String comments;
     protected Double frequency;
     protected Double astigmatismX2Y2;
     protected Double astigmatismXY;
     protected Double astigmatismErr;
     protected Double phaseRMS;
     protected Double surfaceRMS;
     protected Double surfaceRMSNoAstig;
     protected Double ring1RMS;
     protected Double ring2RMS;
     protected Double ring3RMS;
     protected Double ring4RMS;
     protected Double ring5RMS;
     protected Double ring6RMS;
     protected Double ring7RMS;
     protected Double ring8RMS;
     protected String beamMapFitUID;
     protected String surfaceMapFitUID;
     protected Double XFocus;
     protected Double XFocusErr;
     protected Double YFocus;
     protected Double YFocusErr;
     protected Double ZFocus;
     protected Double ZFocusErr;

    public Holography() {
    }
   
    @Id @GeneratedValue(generator="alma_acs_tmcdb_Holography_HolographyIdGenerator")
    @GenericGenerator(name="alma_acs_tmcdb_Holography_HolographyIdGenerator", strategy="native",
       parameters = {@Parameter(name="sequence", value="Holography_seq")}
	)

    
    @Column(name="`HOLOGRAPHYID`", unique=true, nullable=false)
    public Integer getHolographyId() {
        return this.holographyId;
    }

    
    public void setHolographyId(Integer holographyId) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("holographyId", this.holographyId, this.holographyId = holographyId);
        else
            this.holographyId = holographyId;
    }


@ManyToOne(fetch=FetchType.LAZY)
    @JoinColumn(name="`REFERENCEANTENNA`", nullable=false)
    public Antenna getAntennaByReferenceantenna() {
        return this.antennaByReferenceantenna;
    }

    
    public void setAntennaByReferenceantenna(Antenna antennaByReferenceantenna) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("antennaByReferenceantenna", this.antennaByReferenceantenna, this.antennaByReferenceantenna = antennaByReferenceantenna);
        else
            this.antennaByReferenceantenna = antennaByReferenceantenna;
    }


@ManyToOne(fetch=FetchType.LAZY)
    @JoinColumn(name="`ANTENNAID`", nullable=false)
    public Antenna getAntennaByAntennaid() {
        return this.antennaByAntennaid;
    }

    
    public void setAntennaByAntennaid(Antenna antennaByAntennaid) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("antennaByAntennaid", this.antennaByAntennaid, this.antennaByAntennaid = antennaByAntennaid);
        else
            this.antennaByAntennaid = antennaByAntennaid;
    }


    
    @Column(name="`OBSERVATIONTIME`", nullable=false)
    public Long getObservationTime() {
        return this.observationTime;
    }

    
    public void setObservationTime(Long observationTime) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("observationTime", this.observationTime, this.observationTime = observationTime);
        else
            this.observationTime = observationTime;
    }


    
    @Column(name="`EXECBLOCKUID`", nullable=false, length=100)
    public String getExecBlockUID() {
        return this.execBlockUID;
    }

    
    public void setExecBlockUID(String execBlockUID) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("execBlockUID", this.execBlockUID, this.execBlockUID = execBlockUID);
        else
            this.execBlockUID = execBlockUID;
    }


    
    @Column(name="`SCANNUMBER`", nullable=false)
    public Integer getScanNumber() {
        return this.scanNumber;
    }

    
    public void setScanNumber(Integer scanNumber) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("scanNumber", this.scanNumber, this.scanNumber = scanNumber);
        else
            this.scanNumber = scanNumber;
    }


    
    @Column(name="`OBSERVATIONDURATION`", nullable=false, precision=64, scale=0)
    public Double getObservationDuration() {
        return this.observationDuration;
    }

    
    public void setObservationDuration(Double observationDuration) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("observationDuration", this.observationDuration, this.observationDuration = observationDuration);
        else
            this.observationDuration = observationDuration;
    }


    
    @Column(name="`LOWELEVATION`", nullable=false, precision=64, scale=0)
    public Double getLowElevation() {
        return this.lowElevation;
    }

    
    public void setLowElevation(Double lowElevation) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("lowElevation", this.lowElevation, this.lowElevation = lowElevation);
        else
            this.lowElevation = lowElevation;
    }


    
    @Column(name="`HIGHELEVATION`", nullable=false, precision=64, scale=0)
    public Double getHighElevation() {
        return this.highElevation;
    }

    
    public void setHighElevation(Double highElevation) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("highElevation", this.highElevation, this.highElevation = highElevation);
        else
            this.highElevation = highElevation;
    }


    
    @Column(name="`MAPSIZE`", nullable=false, precision=64, scale=0)
    public Double getMapSize() {
        return this.mapSize;
    }

    
    public void setMapSize(Double mapSize) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("mapSize", this.mapSize, this.mapSize = mapSize);
        else
            this.mapSize = mapSize;
    }


    
    @Column(name="`SOFTWAREVERSION`", nullable=false, length=100)
    public String getSoftwareVersion() {
        return this.softwareVersion;
    }

    
    public void setSoftwareVersion(String softwareVersion) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("softwareVersion", this.softwareVersion, this.softwareVersion = softwareVersion);
        else
            this.softwareVersion = softwareVersion;
    }


    
    @Column(name="`OBSMODE`", nullable=false, length=80)
	@Type(type="ObsModeEnum")
    public ObsModeEnum getObsMode() {
        return this.obsMode;
    }

    
    public void setObsMode(ObsModeEnum obsMode) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("obsMode", this.obsMode, this.obsMode = obsMode);
        else
            this.obsMode = obsMode;
    }


    
    @Column(name="`COMMENTS`", length=16777216)
    public String getComments() {
        return this.comments;
    }

    
    public void setComments(String comments) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("comments", this.comments, this.comments = comments);
        else
            this.comments = comments;
    }


    
    @Column(name="`FREQUENCY`", nullable=false, precision=64, scale=0)
    public Double getFrequency() {
        return this.frequency;
    }

    
    public void setFrequency(Double frequency) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("frequency", this.frequency, this.frequency = frequency);
        else
            this.frequency = frequency;
    }


    
    @Column(name="`ASTIGMATISMX2Y2`", nullable=false, precision=64, scale=0)
    public Double getAstigmatismX2Y2() {
        return this.astigmatismX2Y2;
    }

    
    public void setAstigmatismX2Y2(Double astigmatismX2Y2) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("astigmatismX2Y2", this.astigmatismX2Y2, this.astigmatismX2Y2 = astigmatismX2Y2);
        else
            this.astigmatismX2Y2 = astigmatismX2Y2;
    }


    
    @Column(name="`ASTIGMATISMXY`", nullable=false, precision=64, scale=0)
    public Double getAstigmatismXY() {
        return this.astigmatismXY;
    }

    
    public void setAstigmatismXY(Double astigmatismXY) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("astigmatismXY", this.astigmatismXY, this.astigmatismXY = astigmatismXY);
        else
            this.astigmatismXY = astigmatismXY;
    }


    
    @Column(name="`ASTIGMATISMERR`", nullable=false, precision=64, scale=0)
    public Double getAstigmatismErr() {
        return this.astigmatismErr;
    }

    
    public void setAstigmatismErr(Double astigmatismErr) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("astigmatismErr", this.astigmatismErr, this.astigmatismErr = astigmatismErr);
        else
            this.astigmatismErr = astigmatismErr;
    }


    
    @Column(name="`PHASERMS`", nullable=false, precision=64, scale=0)
    public Double getPhaseRMS() {
        return this.phaseRMS;
    }

    
    public void setPhaseRMS(Double phaseRMS) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("phaseRMS", this.phaseRMS, this.phaseRMS = phaseRMS);
        else
            this.phaseRMS = phaseRMS;
    }


    
    @Column(name="`SURFACERMS`", nullable=false, precision=64, scale=0)
    public Double getSurfaceRMS() {
        return this.surfaceRMS;
    }

    
    public void setSurfaceRMS(Double surfaceRMS) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("surfaceRMS", this.surfaceRMS, this.surfaceRMS = surfaceRMS);
        else
            this.surfaceRMS = surfaceRMS;
    }


    
    @Column(name="`SURFACERMSNOASTIG`", nullable=false, precision=64, scale=0)
    public Double getSurfaceRMSNoAstig() {
        return this.surfaceRMSNoAstig;
    }

    
    public void setSurfaceRMSNoAstig(Double surfaceRMSNoAstig) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("surfaceRMSNoAstig", this.surfaceRMSNoAstig, this.surfaceRMSNoAstig = surfaceRMSNoAstig);
        else
            this.surfaceRMSNoAstig = surfaceRMSNoAstig;
    }


    
    @Column(name="`RING1RMS`", nullable=false, precision=64, scale=0)
    public Double getRing1RMS() {
        return this.ring1RMS;
    }

    
    public void setRing1RMS(Double ring1RMS) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("ring1RMS", this.ring1RMS, this.ring1RMS = ring1RMS);
        else
            this.ring1RMS = ring1RMS;
    }


    
    @Column(name="`RING2RMS`", nullable=false, precision=64, scale=0)
    public Double getRing2RMS() {
        return this.ring2RMS;
    }

    
    public void setRing2RMS(Double ring2RMS) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("ring2RMS", this.ring2RMS, this.ring2RMS = ring2RMS);
        else
            this.ring2RMS = ring2RMS;
    }


    
    @Column(name="`RING3RMS`", nullable=false, precision=64, scale=0)
    public Double getRing3RMS() {
        return this.ring3RMS;
    }

    
    public void setRing3RMS(Double ring3RMS) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("ring3RMS", this.ring3RMS, this.ring3RMS = ring3RMS);
        else
            this.ring3RMS = ring3RMS;
    }


    
    @Column(name="`RING4RMS`", nullable=false, precision=64, scale=0)
    public Double getRing4RMS() {
        return this.ring4RMS;
    }

    
    public void setRing4RMS(Double ring4RMS) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("ring4RMS", this.ring4RMS, this.ring4RMS = ring4RMS);
        else
            this.ring4RMS = ring4RMS;
    }


    
    @Column(name="`RING5RMS`", nullable=false, precision=64, scale=0)
    public Double getRing5RMS() {
        return this.ring5RMS;
    }

    
    public void setRing5RMS(Double ring5RMS) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("ring5RMS", this.ring5RMS, this.ring5RMS = ring5RMS);
        else
            this.ring5RMS = ring5RMS;
    }


    
    @Column(name="`RING6RMS`", nullable=false, precision=64, scale=0)
    public Double getRing6RMS() {
        return this.ring6RMS;
    }

    
    public void setRing6RMS(Double ring6RMS) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("ring6RMS", this.ring6RMS, this.ring6RMS = ring6RMS);
        else
            this.ring6RMS = ring6RMS;
    }


    
    @Column(name="`RING7RMS`", nullable=false, precision=64, scale=0)
    public Double getRing7RMS() {
        return this.ring7RMS;
    }

    
    public void setRing7RMS(Double ring7RMS) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("ring7RMS", this.ring7RMS, this.ring7RMS = ring7RMS);
        else
            this.ring7RMS = ring7RMS;
    }


    
    @Column(name="`RING8RMS`", nullable=false, precision=64, scale=0)
    public Double getRing8RMS() {
        return this.ring8RMS;
    }

    
    public void setRing8RMS(Double ring8RMS) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("ring8RMS", this.ring8RMS, this.ring8RMS = ring8RMS);
        else
            this.ring8RMS = ring8RMS;
    }


    
    @Column(name="`BEAMMAPFITUID`", nullable=false, length=100)
    public String getBeamMapFitUID() {
        return this.beamMapFitUID;
    }

    
    public void setBeamMapFitUID(String beamMapFitUID) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("beamMapFitUID", this.beamMapFitUID, this.beamMapFitUID = beamMapFitUID);
        else
            this.beamMapFitUID = beamMapFitUID;
    }


    
    @Column(name="`SURFACEMAPFITUID`", nullable=false, length=100)
    public String getSurfaceMapFitUID() {
        return this.surfaceMapFitUID;
    }

    
    public void setSurfaceMapFitUID(String surfaceMapFitUID) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("surfaceMapFitUID", this.surfaceMapFitUID, this.surfaceMapFitUID = surfaceMapFitUID);
        else
            this.surfaceMapFitUID = surfaceMapFitUID;
    }


    
    @Column(name="`XFOCUS`", nullable=false, precision=64, scale=0)
    public Double getXFocus() {
        return this.XFocus;
    }

    
    public void setXFocus(Double XFocus) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("XFocus", this.XFocus, this.XFocus = XFocus);
        else
            this.XFocus = XFocus;
    }


    
    @Column(name="`XFOCUSERR`", nullable=false, precision=64, scale=0)
    public Double getXFocusErr() {
        return this.XFocusErr;
    }

    
    public void setXFocusErr(Double XFocusErr) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("XFocusErr", this.XFocusErr, this.XFocusErr = XFocusErr);
        else
            this.XFocusErr = XFocusErr;
    }


    
    @Column(name="`YFOCUS`", nullable=false, precision=64, scale=0)
    public Double getYFocus() {
        return this.YFocus;
    }

    
    public void setYFocus(Double YFocus) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("YFocus", this.YFocus, this.YFocus = YFocus);
        else
            this.YFocus = YFocus;
    }


    
    @Column(name="`YFOCUSERR`", nullable=false, precision=64, scale=0)
    public Double getYFocusErr() {
        return this.YFocusErr;
    }

    
    public void setYFocusErr(Double YFocusErr) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("YFocusErr", this.YFocusErr, this.YFocusErr = YFocusErr);
        else
            this.YFocusErr = YFocusErr;
    }


    
    @Column(name="`ZFOCUS`", nullable=false, precision=64, scale=0)
    public Double getZFocus() {
        return this.ZFocus;
    }

    
    public void setZFocus(Double ZFocus) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("ZFocus", this.ZFocus, this.ZFocus = ZFocus);
        else
            this.ZFocus = ZFocus;
    }


    
    @Column(name="`ZFOCUSERR`", nullable=false, precision=64, scale=0)
    public Double getZFocusErr() {
        return this.ZFocusErr;
    }

    
    public void setZFocusErr(Double ZFocusErr) {    
        if( propertyChangeSupport != null )
            propertyChangeSupport.firePropertyChange("ZFocusErr", this.ZFocusErr, this.ZFocusErr = ZFocusErr);
        else
            this.ZFocusErr = ZFocusErr;
    }





}


